function Planner( 
        AA0::AiyagariModelEGM,              
        Aggs_ss::AggVarsEGM{T,T},
        proj::Projection,
        nc::Integer) where {T <: Real}



@unpack params,aGrid,na,dGrid,nd,ns,Transv,Transe = AA0
 @unpack α,γ,β,χ,ϕ,δ = params
w = proj.w
R = proj.R
τ = Aggs_ss.τ
PHI = Aggs_ss.PHI
Se = proj.Se
Su = 1-Se
    
Ltot = Se*(χ*(1-τ)*w)^ϕ
K = sum(proj.at)
Size = proj.Size

N    = proj.N
Nbin = proj.Nbin
Ntoi = proj.Ntoi
Nidio = ns*2
etype = zeros(Integer,Nbin)
ytype = zeros(Integer,Nbin)
yetype = zeros(Integer,Nbin)



for k=1:Nbin
        i = Ntoi[k] #number of the history
        vE =  convertBasis10E(i, Nidio, N)
        ytype[k] = mod(vE[1] - 1 ,ns)+1 # productivity type between 1 and ns
        etype[k] = 1*(vE[1]<=ns)+2*(vE[1]>ns) # employment status (1 unemployed 2 employed)
        yetype[k] = vE[1]  #between 1 and ns*2
end  

Vy = states[ytype] #vector of type
Vyl = states[ytype].*proj.Ls[collect(ytype'.+ ns)]' # vector of y*l, be careful, I have to consider only the labor supply of employed



Transp = proj.Transp #(per capita)
PIL =     diagm(1 ./Size)*Transp*diagm(Size)   # be careful Already multiplied by size and from t+1 to t (not transpose)

FK   = proj.R-1
vect =   β*α*(1-α)/((1+α*ϕ)*Ltot)*((K/Ltot)^(α-1))*( (1-τ)*(etype.-1.0) + (Se/Su)*τ*(1+ϕ)*(2 .- etype )).*
    Size.*Vyl
matpil              = ones(Nbin,1)*vect'
PIpsi               =  β*(1 + FK)*Transp' + matpil





X = proj.X
τ = Aggs_ss.τ
Ucc  = -γ.*(X).^(-γ-1)
Uc   = (X).^-γ
U1 = proj.xsiU.*Uc
Id = sparse(I,Nbin,Nbin)
Onev = ones(Float64,Nbin)'


####################
#Defined CC bin
####################  
#at least one constrained CC
#Ths =   maximum(abs.(proj.CC))
#if Ths<Th
#        Th=Ths
#end
#indcc=findall(x->x>=Th,proj.CC)        # index of bin where fraction of CC is above Th

Th = sort(proj.CC,rev=true)[nc] # the item nc of CC in decreasing order
        
Id = sparse(I,Nbin,Nbin)
indcc=findall(x->x>=Th,proj.CC)        # index of bin where fraction of CC is above Th
    
    
    
#indcc = argmax(proj.Res)
PP = copy(Id)
for ii=1:length(indcc)
    PP[indcc[ii],indcc[ii]]= 0
end
PPc = Id - PP

M = diagm(proj.xsiUc.*Ucc)*(Id - (1+FK)*PIL)
c1 = (β*α*(1-α)/((1+α*ϕ)*Ltot))*( (K/Ltot)^(α-2))*sum(proj.at.*U1); #proj.at (beginning-of-period not per capita

V1 = (β*α*(1-α)/((1+α*ϕ)*Ltot))*( (K/Ltot)^(α-2))*
Onev*(diagm(proj.Size.*proj.xsiUc.*Uc)*PIL - diagm(proj.at)*M)



MATR = PP*((PIpsi - Id)*M + ones(Float64,Nbin)*V1)+PPc

lambda = inv(MATR)* PP*((PIpsi-Id)*U1-c1*ones(Float64,Nbin))
lambda[indcc] .= 0

#lambda = 0 .*lambda     
#U1 = 1.0 .+ 0*U1
#τ = 0

PSI     = U1 - M*lambda
Glambda = PIL*lambda

C = c1+V1*lambda


# implied tau
AE   = (1-τ)*K*sum(Vyl.* proj.Size.*PSI.*(etype .- 1.0))/(Se*Ltot)
AU   = (1-τ+ϕ*(α-τ))*K*sum((Vyl.*proj.Size.*PSI).*(2 .- etype))/(Su*Ltot)
    
sum1 = (α*ϕ/Se)*sum(proj.Size.*Glambda.*proj.xsiUc.*Uc .+ PSI.*proj.at)
sum2 =  β*α*(1-α)/((1+ϕ*α)*Ltot)*( (K/Ltot)^(α-1))*
   sum( ( (1-τ)*(etype .- 1.0) + (Se/Su)*τ*(1+ϕ)*(2 .- etype) ).*Size.*Vyl.*PSI)
Res    = sum1 + AE -AU
    
#cons = sum2 - β*α*(1-α)/(Ltot*(1+α*ϕ))*( (K/Ltot)^(α-2))*sum1*Se/(α*ϕ)
# it is also cons = sum2 - C
#    CHECK = PSI -  β*(1 + FK)*Transp'*PSI - ones(Float64,28)*cons # = 0 sauf CC
    
plan = planstruct(lambda,Glambda,PSI,Res,AE,AU,sum1,sum2)
     
return plan,U1,etype,Vyl,yetype
end